import mido, argparse
#import Serial

parser = argparse.ArgumentParser(description='Translate serial messages into midi')
parser.add_argument('path', type=str, help='path to serial')
args = parser.parse_args()
print(args.path)

#midi_out = mido.open_output("Midia In", virtual=True)
#midi_out = mido.open_output('IAC Driver Bus 1', virtual=True)
midi_out = mido.open_output('midivil', virtual=True)

#mcu_path = "/dev/cu.wchusbserial410"
#mcu_path = "/dev/cu.wchusbserial620"
mcu_path = args.path
#mcu = open(mcu_path,'w+b')
import serial


import os
#os.system("stty -f {} 57600".format(mcu_path))
mcu = serial.Serial(args.path, 57600)

for i in range(5):
    mcu.readline()

parser = mido.Parser()

while True:
    # Check TX to make midi
    line = mcu.readline().strip()
    if len(line):
        parser.feed([int(line, 16)])
        #print(line,len(line))
        while parser.pending() > 0:
            msg = parser.get_message()
            if msg.type != 'active_sensing':
                print(msg)
                midi_out.send(msg)
