import mido, argparse
#import Serial

parser = argparse.ArgumentParser(description='Translate serial messages into midi')
parser.add_argument('path', type=str, help='path to serial')
args = parser.parse_args()
print(args.path)

#midi_out = mido.open_output("Midia In", virtual=True)
#midi_out = mido.open_output('IAC Driver Bus 1', virtual=True)
midi_out = mido.open_output('midivil', virtual=True)

#mcu_path = "/dev/cu.wchusbserial410"
#mcu_path = "/dev/cu.wchusbserial620"
mcu_path = args.path
#mcu = open(mcu_path,'w+b')
import serial


import os
#os.system("stty -f {} 57600".format(mcu_path))
mcu = serial.Serial(args.path, 115200)

for i in range(5):
    mcu.readline()

# you might get ['0x81', '0xffffffff', '0x53']
# or this:
# ['0x81', '0xffffffff', '0x43']
# ['0x34', '0xffffffff', '0x80']
# ['0x46', '0x29', '0xffffffff']
while True:
    # Check TX to make midi
    line = mcu.readline().strip()
    #if bytes([0xff]) not in line and b'?' not in line:
    if len(line):
        print(line,len(line))
        arr = line.split(b' ')[:3]
        cmd, key, vel = [int(hexstr, 16) for hexstr in arr]
        print([hex(i) for i in [cmd,key,vel]])
        if key < 128 and vel < 128:
            midi_out.send( mido.Message.from_bytes([cmd, key, vel]) )
